Index: html/includes/graphs/generic_multi_seperated.inc.php
===================================================================
--- html/includes/graphs/generic_multi_seperated.inc.php	(revision 4254)
+++ html/includes/graphs/generic_multi_seperated.inc.php	(working copy)
@@ -79,7 +79,10 @@
 
   if ($i) { $stack="STACK"; }
 
-  $rrd_options .= " AREA:inbits".$i."#" . $colour_in . ":'" . rrdtool_escape($rrd['descr'], 10) . "In ':$stack";
+  $rrd_options .= " AREA:inbits".$i."#" . $colour_in . ":'" . rrdtool_escape($rrd['descr'], 10) . "In '";
+  if( $stack == "STACK" ){
+    $rrd_options .= ":$stack";
+  }
   $rrd_options .= " GPRINT:inbits".$i.":LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:inbits".$i.":AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:inbits".$i.":MAX:%5.2lf%s";
@@ -87,8 +90,11 @@
   if (!$nototal) { $rrd_options .= " GPRINT:totinB".$i.":%5.2lf%s$total_units"; }
 
   $rrd_options .= " COMMENT:'\\n'";
-  $rrd_optionsb .= " AREA:outbits".$i."_neg#" . $colour_out . "::$stack";
-  $rrd_options .= "  HRULE:999999999999999#" . $colour_out . ":'" . substr(str_pad('', 10),0,10) . "Out':";
+  $rrd_optionsb .= " AREA:outbits".$i."_neg#" . $colour_out ;
+  if( $stack == "STACK" ){
+    $rrd_optionsb .= "::$stack";
+  }
+  $rrd_options .= "  HRULE:999999999999999#" . $colour_out . ":'" . substr(str_pad('', 10),0,10) . "Out'";
   $rrd_options .= " GPRINT:outbits".$i.":LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:outbits".$i.":AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:outbits".$i.":MAX:%5.2lf%s";
@@ -143,21 +149,21 @@
 
   $rrd_options .= " COMMENT:' \\n'";
 
-  $rrd_options .= " HRULE:999999999999999#FFFFFF:'" . substr(str_pad('Total', 10),0,10) . "In ':";
+  $rrd_options .= " HRULE:999999999999999#FFFFFF:'" . substr(str_pad('Total', 10),0,10) . "In '";
   $rrd_options .= " GPRINT:inbits:LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:inbits:AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:inbits:MAX:%5.2lf%s";
   $rrd_options .= " GPRINT:totin:%5.2lf%s$total_units";
   $rrd_options .= " COMMENT:'\\n'";
 
-  $rrd_options .= " HRULE:999999999999990#FFFFFF:'" . substr(str_pad('', 10),0,10) . "Out':";
+  $rrd_options .= " HRULE:999999999999990#FFFFFF:'" . substr(str_pad('', 10),0,10) . "Out'";
   $rrd_options .= " GPRINT:outbits:LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:outbits:AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:outbits:MAX:%5.2lf%s";
   $rrd_options .= " GPRINT:totout:%5.2lf%s$total_units";
   $rrd_options .= " COMMENT:'\\n'";
 
-  $rrd_options .= " HRULE:999999999999990#FFFFFF:'" . substr(str_pad('', 10),0,10) . "Agg':";
+  $rrd_options .= " HRULE:999999999999990#FFFFFF:'" . substr(str_pad('', 10),0,10) . "Agg'";
   $rrd_options .= " GPRINT:bits:LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:bits:AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:bits:MAX:%5.2lf%s";
@@ -186,21 +192,21 @@
   $rrd_options .= " VDEF:totX=octetsX,TOTAL";
   $rrd_options .= " COMMENT:' \\n'";
 
-  $rrd_options .= " HRULE:999999999999999#aaaaaa:'" . substr(str_pad('Total', 10),0,10) . "In ':";
+  $rrd_options .= " HRULE:999999999999999#aaaaaa:'" . substr(str_pad('Total', 10),0,10) . "In '";
   $rrd_options .= " GPRINT:inbitsX:LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:inbitsX:AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:inbitsX:MAX:%5.2lf%s";
   $rrd_options .= " GPRINT:totinX:%5.2lf%s$total_units";
   $rrd_options .= " COMMENT:'\\n'";
 
-  $rrd_options .= " HRULE:999999999999990#aaaaaa:'" . substr(str_pad('', 10),0,10) . "Out':";
+  $rrd_options .= " HRULE:999999999999990#aaaaaa:'" . substr(str_pad('', 10),0,10) . "Out'";
   $rrd_options .= " GPRINT:outbitsX:LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:outbitsX:AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:outbitsX:MAX:%5.2lf%s";
   $rrd_options .= " GPRINT:totoutX:%5.2lf%s$total_units";
   $rrd_options .= " COMMENT:'\\n'";
 
-  $rrd_options .= " HRULE:999999999999990#aaaaaa:'" . substr(str_pad('', 10),0,10) . "Agg':";
+  $rrd_options .= " HRULE:999999999999990#aaaaaa:'" . substr(str_pad('', 10),0,10) . "Agg'";
   $rrd_options .= " GPRINT:bitsX:LAST:%5.2lf%s";
   $rrd_options .= " GPRINT:bitsX:AVERAGE:%5.2lf%s";
   $rrd_options .= " GPRINT:bitsX:MAX:%5.2lf%s";